<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2009 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
  
  ********************************************
  Coppermine version: 1.4.25
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/trunk/cpg1.4.x/bridge/phpbb22.inc.php $
  $Revision: 5997 $
  $Author: gaugau $
  $Date: 2009-05-26 08:43:24 +0200 (Di, 26 Mai 2009) $
**********************************************/

/*
Updated for Typo3 on 09.09.09 bay Stefan Osterlitz
/* 


*/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 1);

require_once 'bridge/udb_base.inc.php';
error_log("cpg: start");
class cpg_udb extends core_udb {

	function cpg_udb()
	{
		global $BRIDGE;
		
		if (!USE_BRIDGEMGR) { // the vars that are used when bridgemgr is disabled

			// URL of your punbb
			$this->boardurl = 'http://www.haller-kreisblatt.de/';

			// local path to your config file
			require_once('../typo3conf/localconf.php');

		} else { // the vars from the bridgemgr
			$this->boardurl = $BRIDGE['full_forum_url'];
			require_once($BRIDGE['relative_path_to_config_file'] . 'localconf.php');
		}
		
		// Database connection settings
		$this->db = array(
			'name' => $typo_db,
			'host' => $typo_db_host ? $typo_db_host : 'localhost',
			'user' => $typo_db_username,
			'password' => $typo_db_password,
			'prefix' =>''
		);
		
		// Board table names
		$this->table = array(
			'users' => 'fe_users',
			'groups' => 'fe_groups',
			'sessions' => 'fe_sessions',
			'session_data' => 'fe_session_data'
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		$this->sessionstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['sessions'];
		$this->sessiondatatable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['session_data'];
		
		// Table field names
		$this->field = array(
			'username' => 'username', // name of 'username' field in users table
			'user_id' => 'uid', // name of 'id' field in users table
			'password' => 'password', // name of 'password' field in users table
			'email' => 'email', // name of 'email' field in users table
			'regdate' => 'UNIX_TIMESTAMP(crdate)', // name of 'registered' field in users table
			'active' => '1', // is user account active?
			'lastvisit' => 'UNIX_TIMESTAMP(lastlogin)', // name of 'location' field in users table
			'location' => 'address', // name of 'location' field in users table
			'website' => 'www', // name of 'website' field in users table
			'usertbl_group_id' => 'usergroup', // name of 'group id' field in users table
			'grouptbl_group_id' => 'uid', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'title' // name of 'group name' field in groups table
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => '',
			'editusers' => '',
			'edituserprofile' => '',
      'login_page' => '',
      'logout_page' => '?logintype=logout',
		);

		// Group ids
		$this->admingroups = array(27);
		$this->guestgroup = 1;
		// Cookie settings - used in following functions only
		$this->cookie_name = $BRIDGE['cookie_prefix'] ? $BRIDGE['cookie_prefix'] : "fe_typo_user";
		$this->cookie_seed = '';
		
		// Connect to db
		$this->connect();
	}

	// definition of how to extract id, name, group from a session cookie
	function session_extraction()
	{
		error_log("sess_extr");
		if (isset($_COOKIE[$this->cookie_name])) {
			$session_id = addslashes($_COOKIE[$this->cookie_name]);
			$sql = "SELECT uid, password, usergroup FROM {$this->sessionstable} INNER JOIN {$this->usertable} ON ses_userid = uid WHERE ses_id='$session_id';"; // AND session_user_id ='$cookie_id'"; (Maybe session_id is unique enough?)
			
			$result = cpg_db_query($sql, $this->link_id);
			
			if (mysql_num_rows($result)){
				$row = mysql_fetch_array($result);
				$row[usergroup]=split(",",$row[usergroup]);
				return $row;
			} else {
			    return false;
			}
		}
	}
	
	// definition of how to extract an id and password hash from a cookie
	function cookie_extraction()
	{
		error_log("cpg: cookie_extr");
	    	$id = 0;
		$pass = '';

		if (isset($_COOKIE[$this->cookie_name])) {
			$session_id = addslashes($_COOKIE[$this->cookie_name]);
			$sql = "SELECT uid, username, password, usergroup FROM {$this->sessionstable} INNER JOIN {$this->usertable} ON ses_userid = uid WHERE ses_id='$session_id';"; // AND session_user_id ='$cookie_id'"; (Maybe session_id is unique enough?)
			
			$result = cpg_db_query($sql, $this->link_id);
			
			if (mysql_num_rows($result)){
				$row = mysql_fetch_array($result);
				return $row;
			} else {
			    return false;
			}
		}
		return ($row[uid]) ? array($row[uid], $row[password]) : false;
	}
	
	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password; // unused
	}
	
	function login_page()
	{
		global $CONFIG;
		
		$redirect = urlencode($CONFIG['site_url']);
    $this->redirect($this->page[login_page]);
	}

	function logout_page()
	{
		global $CONFIG;
		
		$redirect = urlencode($CONFIG['site_url']);
    $this->redirect($this->page[logout_page]);
	}

}

// and go !
$cpg_udb = new cpg_udb;
?>
